Skip to main content Skip to footer

Build Vue Apps with Wijmo and the New Vue CLI 3.0

  • 0 Comments

Notice: Code examples in this blog use Wijmo modules from the non-scoped ‘wijmo’ npm package. Beginning with Wijmo 2019 v1 release, Wijmo packages are also available in the @grapecity npm scope, and the use of these packages is the recommended for new applications. For the convenience of our customers, we continue publishing new Wijmo builds as non-scoped ‘wijmo’ packages as well.

Read more about Wijmo NPM Package Changes.

In this series, we'll show how you can use Wijmo with NPM and Webpack to create applications targeting the most popular JavaScript application frameworks. This blog focuses on Vue.js, an ecosystem that scales between a library and a full-featured framework, Vue.js is the smallest and least opinionated framework on this list. It lets you write traditional HTML and JavaScript, or “vue” files, that combine HTML, JS, and CSS to create encapsulated reusable components. Read about Wijmo's support of Vue.js

Blog series

1. Introduction to NPM and Wijmo

2. Angular

3. React

4. Vue.js

5. Ionic

In this tutorial, we won't get into the details of NPM, Webpack, or Vue.js itself. All these tools are incredibly popular and thoroughly documented, and you can read our e-book on frameworks for a good overview. Instead, we'll focus on the task of adding Wijmo to simple applications written in Vue.js.

The basic steps for creating and maintaining applications are the same in all frameworks:

  • Install the appropriate CLI (Command-Line Interface utility) to generate, run, maintain, and deploy applications.

  • Use the CLI to create the application.

  • Use NPM to add Wijmo to the application.

  • Import the components you want to use and add the appropriate markup.

The latest Vue CLI 3.0 brings a variety of great enhancements. With built-in support for all the popular tools, developers do not have to learn the tools all on their own. It also has a graphical user interface that makes it easy to edit projects without having to remember thousands of options for different tools.

These are the updated steps required create a new VueJS app and get it up and running:

Step 1. Create a new Vue.js app


Task
Command
Install Vue CLI 3.0 npm install -g @vue/cli
Create app vue create my-vue-app-3
Switch to app folder cd my-vue-app-3
Add Wijmo to the app npm install wijmo
Launch GUI vue ui

Step 2:

The next step is to use the GUI to enable Vue’s runtime compiler. The runtime compiler is required by the current version of the Wijmo Vue interop (this will not be necessary in the next version of Wijmo’s Vue interop):

Vue.js app

Don’t forget to click the “Save Changes” button after enabling the runtime compiler.
You can now run the app from the GUI as shown below:

Vue.js app

This has the same effect as running the app from the command line:

npm run serve

You should see the app running in the browser. Let’s start editing the app. Whenever you save any changes, the browser will re-load the app automatically.

VueJS projects usually define components in files with a “vue” extension. These files contain the HTML, JavaScript, and CSS for the components. This is like React, where markup and script are bundled into JSX files.

The sample app has two components: App and HelloWorld. The first is the main component. It displays the VueJS logo and HelloWorld component below.

Open the src/components/HelloWorld.vue file in VS Code and start by editing the HTML part of the file:

<template>  
  <div class="hello">  
    <h1>{{ msg }}</h1>  
    <h2>Here are some Wijmo controls for you to get started:</h2>  
    <div class="App-panel">  
      <wj-flex-grid  
        :itemsSource="data">  
      </wj-flex-grid>  
      <wj-flex-chart  
        :itemsSource="data"  
        bindingX="country">  
        <wj-flex-chart-series name="Sales" binding="sales">  
        </wj-flex-chart-series>  
        <wj-flex-chart-series name="Expenses" binding="expenses">  
        </wj-flex-chart-series>  
        <wj-flex-chart-series name="Downloads" binding="downloads">  
        </wj-flex-chart-series>  
      </wj-flex-chart>  
    </div>  
  </div>  
</template>  

The markup looks a lot like Angular. Directives correspond to Wijmo controls or classes, and attributes correspond to properties.

Step 3. Add the Wijmo controls and their data

Now let us look at the JavaScript part of the code, right below the HTML:

<script>  
  // import Wijmo  
  import 'wijmo/wijmo.vue2.grid';  
  import 'wijmo/wijmo.vue2.chart';  
  import { CollectionView } from 'wijmo/wijmo';  

  // apply Wijmo license key (if you have one)  
  //import { setLicenseKey } from 'wijmo/wijmo';  
  //setLicenseKey('your key goes here');  

  function getData() {  
    var countries = 'US,Germany,UK,Japan,Italy,Greece'.split(','),  
        data = [];  
    for (var i = 0; i < countries.length; i++) {  
      data.push({  
        country: countries[i],  
        sales: Math.random() * 10000,  
        expenses: Math.random() * 5000,  
        downloads: Math.round(Math.random() * 20000),  
      });  
    }  
    return new CollectionView(data);  
  }  

  export default {  
    name: 'HelloWorld',  
    data: function() {  
      return {  
        msg: 'Welcome to Your Vue.js App',  
        data: getData()  
      }  
    }  
  }  
</script>  

The code imports the Wijmo styles and components, then exports an object that contains the message to show on the screen and the data to show in the controls.

Step 4. Update the stylesheet

The file ends with a few CSS rules:

<!-- Add "scoped" attribute to limit CSS to this component only -->  
<style scoped>  
  .App-panel {  
    margin: 0 48pt;  
  }  
  .App-panel .wj-control {  
    display: inline-block;  
    vertical-align: top;  
    width: 400px;  
    height: 300px;  
  }  
</style>  

Press ctrl+S to save the changes.

To finish, open the ‘src/App.vue’ file in VS Code and add a line to import Wijmo’s css file:

<style>  
@import "../node_modules/wijmo/styles/wijmo.css";  

#app {  
  font-family: 'Avenir', Helvetica, Arial, sans-serif;  
  -webkit-font-smoothing: antialiased;  
  -moz-osx-font-smoothing: grayscale;  
  text-align: center;  
  color: #2c3e50;  
  margin-top: 60px;  
}  
</style>  

Press ctrl+S to save the file and switch to the browser to see the result of the changes:

Vue.js app

Because the grid and the chart are bound to the same CollectionView, any changes made to the data in the grid are automatically reflected in the chart. For example, you may click the column headers to sort the data or edit some values using the keyboard.

Usimg Wijmo and modern JavaScript applications

Integrating Wijmo into modern JavaScript applications is just a matter of installing it with NPM and importing the components you want from the library.

Being able to use the exact same UI components on different frameworks makes things easier if you work with multiple frameworks or think you might switch frameworks in the future.

Skip to main content Skip to footer

How to build Angular apps with Wijmo and NPM

  • 0 Comments

Notice: Code examples in this blog use Wijmo modules from the non-scoped ‘wijmo’ npm package. Beginning with Wijmo 2019 v1 release, Wijmo packages are also available in the @grapecity npm scope, and the use of these packages is the recommended for new applications. For the convenience of our customers, we continue publishing new Wijmo builds as non-scoped ‘wijmo’ packages as well.

Read more about Wijmo NPM Package Changes.

Build Angular apps with Wijmo and NPM

In this series, we'll show how you can use Wijmo with NPM and Webpack to create applications targeting the most popular JavaScript application frameworks. This blog focuses on Angular, Google’s framework for building JavaScript applications that live on the web, mobile, or the desktop, this full-featured framework combines declarative templates, dependency injection, and includes end-to-end tooling.

Read more about Wijmo's Angular Components including a powerful Angular DataGrid.

Blog series

1. Introduction to NPM and Wijmo

2. Angular

3. React

4. Vue.js

5. Ionic

In this tutorial, we won't get into the details of NPM, Webpack, or Angular itself. All these tools are incredibly popular and thoroughly documented, and you can read our e-book on frameworks for a good overview. Instead, we'll focus on the task of adding Wijmo to simple applications written in Angular.

The basic steps for creating and maintaining applications are the same in all frameworks:

  • Install the appropriate CLI (Command-Line Interface utility) to generate, run, maintain, and deploy applications.

  • Use the CLI to create the application.

  • Use NPM to add Wijmo to the application.

  • Import the components you want to use and add the appropriate markup.

Step 1. Create a new Angular app

Follow these steps to create a new Angular app and get it up and running:

Task Command
Install CLI npm install -g @angular/cli
Create app ng new my-angular-app
Switch to app folder cd my-angular-app
Add Wijmo to the app npm install wijmo
Start the app ng serve
View app in the browser http://localhost:4200

You should see the app running in the browser. Let’s start editing the app. When you save changes, the browser will reload the app automatically.

Step 2. Add Wijmo modules

Open the “src/app/app.module.ts” file and add the Wijmo modules for the grid and chart:

// src/app/app.module.ts
import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { AppComponent } from './app.component';

// import Wijmo modules
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjChartModule } from 'wijmo/wijmo.angular2.chart';

// apply Wijmo license key
import { setLicenseKey } from 'wijmo/wijmo';
setLicenseKey('your license key goes here');

@NgModule({
  declarations: [
    AppComponent
  ],
  imports: [
    BrowserModule,
    WjGridModule,
    WjChartModule
  ],
  providers: [],
  bootstrap: [AppComponent]
})
export class AppModule { }

In addition to importing the Wijmo modules we want, the code also applies a Wijmo license key to remove the evaluation watermark from the app. If you don’t have a license key, it’s OK to skip this step.

Now that the Wijmo modules have been referenced by the application module, we can use them in our component templates.

Step 3. Add data to the controls

Start by opening the “src/app/app.component.ts” file and give the component some data for the controls:

// src/app/app.component.ts
import { Component } from '@angular/core';

// import Wijmo components
import { CollectionView } from 'wijmo/wijmo';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  title = 'Wijmo Starter App';
  data = this.getData();
  getData() {
    var countries = 'US,Germany,UK,Japan,Italy,Greece'.split(','),
        data = [];
    for (var i = 0; i < countries.length; i++) {
      data.push({
        country: countries[i],
        sales: Math.random() * 10000,
        expenses: Math.random() * 5000,
        downloads: Math.round(Math.random() * 20000),
      });
    }
    return new CollectionView(data);
  }
}

Notice that getData returns a CollectionView rather than a regular array. The CollectionView class supports sorting, filtering, grouping, currency, and notifications. In this example, we'll use it as a data source for a grid and a chart.

Step 4. Add the Angular controls to the app

To add the grid and the chart to the app, edit the src/app/app.component.html file as follows:

<!-- The content below is only a placeholder and can be replaced. -->
<div style="text-align:center">
  <h1>
    Welcome to {{ title }}!
  </h1>
  <img width="100" alt="Angular Logo" src="data:image/svg+xml;base64,PH…">
</div>
<h2>Here are some Wijmo controls to help you start:</h2>
<div class="App-panel">
  <wj-flex-grid [itemsSource]="data">
  </wj-flex-grid>
  <wj-flex-chart [itemsSource]="data" [bindingX]="'country'">
    <wj-flex-chart-series [binding]="'sales'" [name]="'Sales'">
    </wj-flex-chart-series>
    <wj-flex-chart-series [binding]="'expenses'" [name]="'Expenses'">
    </wj-flex-chart-series>
    <wj-flex-chart-series [binding]="'downloads'" [name]="'Downloads'">
    </wj-flex-chart-series>
  </wj-flex-chart>
</div>

Notice the use of the wj-flex-grid, wj-flex-chart, and wj-flex-chart-series directives. These were imported from the grid and chart modules.

Step 5. Update the stylesheet

We're almost done. The last step is adding the CSS. Open the “src/styles.css” file and add this code:

/* 
  You can add global styles to this file,
  and also import other style files
*/
@import "wijmo/styles/wijmo.css";

.App-panel {
    margin: 0 48pt;
    text-align: center;
  }
    .App-panel .wj-control {
      display: inline-block;
      width: 400px;
      height: 300px;
      vertical-align: top;
    }

First, we import Wijmo’s CSS, so all Wijmo controls will be properly styled throughout the app.

Next, we define rules that apply to “App-panel” elements and controls hosted in those elements.

We could also have defined the “App-panel” rules at the component level, in the “app.component.css” file.

Step 6. Test in the browser

Now press ctrl+S to save the changes in all files and switch back to the browser to see the result:

Angular app

Because the grid and the chart are bound to the same CollectionView, any changes made to the data in the grid are automatically reflected in the chart. For example, you may click the column headers to sort the data or edit some values using the keyboard.

Conclusion

Integrating Wijmo into modern Angular applications is just a matter of installing it with NPM and importing the components you want from the library.

Being able to use the exact same UI components on different frameworks makes things easier you work with two or more frameworks, or are planning to switch frameworks in the future.

Read more about Wijmo's Angular Components including a powerful Angular DataGrid.

Download Now!

Skip to main content Skip to footer

How to build React Apps with Wijmo and NPM

  • 0 Comments

Notice: Code examples in this blog use Wijmo modules from the non-scoped ‘wijmo’ npm package. Beginning with Wijmo 2019 v1 release, Wijmo packages are also available in the @grapecity npm scope, and the use of these packages is the recommended for new applications. For the convenience of our customers, we continue publishing new Wijmo builds as non-scoped ‘wijmo’ packages as well.

Read more about Wijmo NPM Package Changes.

Build Angular apps with Wijmo and NPM

In this series, we'll show how you can use Wijmo with NPM and Webpack to create applications targeting the most popular JavaScript application frameworks. This blog focuses on Facebook’s framework React, which calls itself “A JavaScript library for building user interfaces.” It extends JavaScript with an HTML-like syntax for creating components that are combined into applications. Read more about Wijmo's React support.

Blog series

1. Introduction to NPM and Wijmo

2. Angular

3. React

4. Vue.js

5. Ionic

In this tutorial, we won't get into the details of NPM, Webpack, or React itself. All these tools are incredibly popular and thoroughly documented, and you can read our e-book on frameworks for a good overview. Instead, we'll focus on the task of adding Wijmo to simple applications written in React.

The basic steps for creating and maintaining applications are the same in all frameworks:

  • Install the appropriate CLI (Command-Line Interface utility) to generate, run, maintain, and deploy applications.

  • Use the CLI to create the application.

  • Use NPM to add Wijmo to the application.

  • Import the components you want to use and add the appropriate markup.

Step 1. Create a new React app

Follow these steps to create a new React app and get it up and running:

Task Command
Install CLI npm install -g create-react-app
Create app create-react-app my-react-app
Switch to app folder cd my-react-app
Add Wijmo to the app npm install wijmo
Start app npm start
View app in the browser http://localhost:3000

You should see the app running in the browser. Let’s start editing the app. When you save changes, the browser will reload the app automatically.

Step 2. Add Wijmo modules

Open the “src/App.js” file in VS Code and import the elements you want to use. In this case, we'll import Wijmo’s css as well as the CollectionView, FlexGrid, FlexChart, and FlexChartSeries components:


import React, { Component } from 'react';
import logo from './logo.svg';
import './App.css';

// import Wijmo styles and components
import 'wijmo/styles/wijmo.css';
import { CollectionView } from 'wijmo/wijmo';
import { FlexGrid } from 'wijmo/wijmo.react.grid';
import { FlexChart, FlexChartSeries } from 'wijmo/wijmo.react.chart';

// apply Wijmo license key
import { setLicenseKey } from 'wijmo/wijmo';
setLicenseKey('your key goes here'); 

class App extends Component {

In addition to importing the Wijmo modules we want, the code also applies a Wijmo license key to remove the evaluation watermark from the app. If you don’t have a license key, it’s OK to skip this step.

Step 3. Add data to the controls

Now you can use Wijmo in the application. To demonstrate, let’s start by giving the app some state:

class App extends Component {
  constructor(props) {
    super(props);
    this.state = { 
      data: this.getData()
    };
  }
  getData() {
    var countries = 'US,Germany,UK,Japan,Italy,Greece'.split(','),
        data = [];
    for (var i = 0; i < countries.length; i++) {
      data.push({
        country: countries[i],
        sales: Math.random() * 10000,
        expenses: Math.random() * 5000,
        downloads: Math.round(Math.random() * 20000),
      });
    }
    return new CollectionView(data);
  }
  render() {
    // …

This adds a “data” member to the App component’s state.

Notice that getData returns a CollectionView rather than a regular array. The CollectionView class supports sorting, filtering, grouping, currency, and notifications. In this example, we'll use it as a data source for a grid and a chart.

Step 4. Add the React controls to the app

To add the grid and the chart to the app, edit the “src/App.js”file as follows:


class App extends Component {
  constructor(props) {
    // … no change
  }
  getData() {
    // no change
  }
  render() {
    return (
      <div className="App">
        <header className="App-header">
          <img src={logo} className="App-logo" alt="logo" />
          <h1 className="App-title">Welcome to React and Wijmo</h1>
        </header>
        <p className="App-intro">
          To get started, edit <code>src/App.js</code> and save to reload.
        </p>
        <div className="App-panel">
          <FlexGrid itemsSource={this.state.data}/>
          <FlexChart itemsSource={this.state.data} bindingX="country">
            <FlexChartSeries name="Sales" binding="sales"/>
            <FlexChartSeries name="Expenses" binding="expenses"/>
            <FlexChartSeries name="Downloads" binding="downloads"/>
          </FlexChart>
        </div>
      </div>
    );
  }
}

Step 5. Update the stylesheet

Before saving the file, edit the “src/App.css” file to define the layout to be used by the “App-panel” element:


.App-intro {
  font-size: large;
}

.App-panel {
  margin: 0 48pt;
}
.App-panel .wj-control {
  display: inline-block;
  vertical-align: top;
  width: 400px;
  height: 300px;
}
@keyframes App-logo-spin {
  from { transform: rotate(0deg); }
  to { transform: rotate(360deg); }
}

Step 6. Test in the browser

Now press ctrl+S to save the changes and switch back to the browser to see the result of the changes:

React app

Because the grid and the chart are bound to the same CollectionView, any changes made to the data in the grid are automatically reflected in the chart. For example, you may click the column headers to sort the data or edit some values using the keyboard.

Conclusion

Integrating Wijmo into modern JavaScript applications is just a matter of installing it with NPM and importing the components you want from the library.

Being able to use the exact same UI components on different frameworks makes things easier you work with two or more frameworks, or are planning to switch frameworks in the future.